/*
 * terminal.c
 * This file is part of ddterm
 * dropdown terminal for gnome
 * (see kuake and yakuake for kde as a reference)
 *
 * Copyright (C) 2006 - Alberto Piai
 *
 * ddterm is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ddterm is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, 
 * Boston, MA  02110-1301  USA
 */
 

#include <gtk/gtk.h>
#include <vte/vte.h>

#include "terminal.h"

/* private functions
 */
static inline void _setup_term(VteTerminal *);
static void on_child_exited(gpointer);

/* void setup_terminal(VteTerminal *terminal) {{{
 *
 * this is the exported function
 *
 */
void setup_terminal(VteTerminal *terminal)
{
	_setup_term(terminal);
}
/* }}} */

/* static inline void _setup_term(VteTerminal *term_widget) {{{
 *
 * set up the terminal:
 * 	- set background
 * 	- set font
 * 	- connect appropriate signal handlers
 * 
 */
static inline void _setup_term(VteTerminal *term)
{
	vte_terminal_set_background_transparent(term, TRUE);

	vte_terminal_set_font_from_string(term, FONT);

	g_signal_connect(GTK_WIDGET(term), "child-exited", G_CALLBACK(on_child_exited), term);

	return;
}


/* }}} */

/* static void on_child_exited(void) {{{ */
static void on_child_exited(gpointer self)
{
	GtkWindow *parent_window;
	GtkWidget *term_widget;

	term_widget = GTK_WIDGET(self);

	parent_window = GTK_WINDOW(term_widget->parent);
	
	/* g_usleep(500000); */

	g_signal_emit_by_name(parent_window, "destroy-event");
}
/* }}} */
